<?php

namespace RxConnexionBundle\Form;

use Doctrine\Common\Persistence\ObjectManager;
use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\Mapping\Entity;
use RxConnexionBundle\Form\DataTransformer\DataTransformer;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use RxConnexionBundle\Entity\MaterialRequisitionEntity;
use RxConnexionBundle\Entity\MaterialRequisitionNoteEntity;

class MaterialRequisitionNoteForm extends AbstractType
{
    private $manager;

    public function __construct(ObjectManager $manager) {
        $this->manager = $manager;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('action', HiddenType::class, array(
                'mapped' => false,
                'attr' => array(
                    'class' => 'form-action'
                )
            ))
            ->add('materialRequisition_id', HiddenType::class, array(
                'mapped' => false,
                'data' => $options['materialRequisition_id']
            ))
            ->add('id', HiddenType::class)
            ->add('created_by', HiddenType::class)
            ->add('created_at', HiddenType::class)
            ->add('updated_by', HiddenType::class)
            ->add('updated_at', HiddenType::class)
            ->add('subject', TextType::class, array(
                'label' => 'Subject',
                'label_attr' => array(
                    'class' => 'middle required'
                ),
                'required' => true
            ))
            ->add('details', TextareaType::class, array(
                'label' => 'Details',
                'label_attr' => array(
                    'class' => 'middle'
                ),
                'required' => true,
                'attr' => array(
                    'rows' => 4
                )
            ));

//        $builder->get('materialRequisition')->addModelTransformer(new DataTransformer($this->manager, 'RxConnexionBundle:MaterialRequisitionEntity', true));
    }

    public function getBlockPrefix()
    {
        return 'materialRequisitionNote';
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' 	         => 'RxConnexionBundle\Entity\MaterialRequisitionNoteEntity',
            'csrf_protection'        => true,
            'csrf_field_name'        => '_token',
            // a unique key to help generate the secret token
            'intention'              => 'materialRequisitionNoteEntity_intention',
            'action'                 => 'n',
            'materialRequisition_id' => null,
        ));
    }
}